//----------------------------------------------------------------------------------------------------------------------------------------------------//
//								Remove Background in DAV									//
//																							//
//										F. Cheynis											//
//																							//
//										23/05/2014											//
//----------------------------------------------------------------------------------------------------------------------------------------------------//


//23/05/2014 version: M_ROIMask normalisation debugged


#pragma rtGlobals=1		// Use modern global access method.




Function DAVBackground2009(ctrlName) : ButtonControl
	String ctrlName
	
	Nvar FromVar, ToVar, StepVar, RefRead,FrameNumber,PolyOrderVar
	Svar OptionStr
	
	Variable /g RefWrite
	
	Variable Flag, i,NFramesToCorrect, TempVar
	
	String TempStr
	
	//WMCreateImageROIPanel()
	
	Flag=FromToStepDialog(6)
	
	NFramesToCorrect=(ToVar-FromVar)/StepVar+1
	
	TempStr=StrVarOrDefault("root:TopImageWinName","nop!")
	If(stringmatch(TempStr,"nop!"))
		String/G TopImageWaveName,TopImageWinName
	Else
		Svar TopImageWaveName,TopImageWinName
	EndIf
	TopImageWinName=WinName(0,1,1)
	
	If(Flag==0)
		STRUCT UKFileHeader2009 MyFileHeader 
		Fstatus RefRead
		
		open/F="Data Files (*.dav):.dav;All Files:.*;" RefWrite as StringFromList(0, S_fileName,".")+"_back.dav"
		//open/P=MyPath/F="Data Files (*.dav):.dav;All Files:.*;" RefWrite as StringFromList(0, S_fileName,".")+"_drift.dav"
		
		fsetpos RefRead,0
		fsetpos RefWrite,0
		
		FBinRead RefRead, MyFileHeader
		FBinWrite RefWrite, MyFileHeader
	Else
		Abort
	EndIf
	
		
	Dowindow/K $TopImageWinName
	
	If(stringmatch(OptionStr,"No"))
		if (Exists("M_ROIMask")==0)
	 		abort "Abort - Define a ROI to calculate the background" 
		EndIf
	
		Wave 'Wave_i'=DAVLoadFrame2009(FromVar,0)
		Wave M_ROIMask
		M_ROIMask-=1
		M_ROIMask/=255
		ImageRemoveBackground /R=M_ROIMask/F/P=(PolyOrderVar) 'Wave_i'
		KillWaves 'Wave_i'
	EndIf
	
	If(WaveExists(M_RemovedBackground))	
		Wave M_RemovedBackground
		
		For(i=0; i<NFramesToCorrect; i+=1)
			TempVar=FromVar+i*StepVar	
			Wave 'Wave_i'=DAVLoadFrame2009(TempVar,0)
			
			'Wave_i'-=M_RemovedBackground
		     	
		    	DAVWriteFrame2009(NameOfWave('Wave_i'),i)
		 
		      KillWaves 'Wave_i'
		EndFor
	Endif
		
//		RefRead=RefWrite
//		DAVLoadFrame(0,1)
//		Close RefWrite
End